//Root finding by Bisection Method
//
//The following code makes use of the Numerical technique of Finding a root called Bisection(Interval-Halving) Method.
//
//The function bsolve requires four parameters:
//a&b: Initial Guesses(such that the root lies between a&b)
//f: The equation whose root is to be estimated
//tol: The tolerance value or the acceptable error in the root.
//
//NOTE: This method does not find all the roots but only One root near the initial guesses.
//
//To find different roots try using different initial guesses.
//
//The code does not work absolutely all the time for all equations and any inital guess, However with good initial guesses one can always get the answer.
//
//Reference: https://en.wikipedia.org/wiki/Bisection_method
//
//The code is a work in progress and any help/contribution is welcome.
//
funcprot(0);
function c=bsolve(a,b,f,tol)
    if f(a)*f(b)<0 then
        while abs(a-b)>tol do
            c=(a+b)/2;
            if f(c)==0 then
                break;
            elseif f(a)*f(c)<0 then
                b=c;
            else 
                a=c;
            end
        end
    else 
        disp("Either No Root or more than one Root lies between the given value of a & b. Please enter a different value of a & b");
    end
endfunction
