//Root finding by Secant Method
//
//The following code makes use of the Numerical technique of Finding a root called Secant Method.
//
//The function sesolve requires four parameters:
//a&b: Initial Guesses(They should be somewhat near the root, though it is not always necessary)
//f: The equation whose root is to be estimated
//tol: The tolerance value or the acceptable error in the root.
//
//NOTE: This method does not find all the roots but only One root near the initial guesses.
//
//To find different roots try using different initial guesses.
//
//The code does not work absolutely all the time for all equations and any inital guess, However with good initial guesses one can always get the answer.
//
//The code is a work in progress and any help/contribution is welcome.
//
//Reference: https://en.wikipedia.org/wiki/Secant_method
//
//Written By; Manas Sharma(manassharma0@live.com)
//
funcprot(0);
function c=sesolve(a,b,f,tol)
     c=b-f(b)*(a-b)/(f(a)-f(b));
    while abs(c-b)>=tol do
        a=b;
        b=c;
        c=b-f(b)*(a-b)/(f(a)-f(b));
    end
endfunction
